#!/usr/bin/perl

##  Last Updated: 03/15/2000
##  Database Utilities go here. Added universal Insert. Added db_errchk.
##  The db_errchk makes facility of the new errlog function in the utils lib.

sub db_connect {
	my($database) = @_;
	if (!defined($database)) {
		die("Sorry, you must specify the database for the Database Library.");
	}
	use DBI;

	$hostname = "db";
	$user = "netadmin";
	$password = "PASSWORD";
	$port = "5432";
	$driver = "Pg";

#load dem drivers

        $dsn = "DBI:$driver:dbname=$database;host=$hostname;port=$port";
        $dbh = DBI->connect($dsn, $user, $password);
        $drh = DBI->install_driver($driver);

	if ($DBI::err) {
		die($DBI::errstr);
	}

return $dbh;
}

# Example: db_insert('customer',$FieldNames,$FieldValues);
sub db_insert {
my($table,$FieldNames,$FieldValues) = @_;
        my $db_query = "   INSERT INTO $table
                        ($FieldNames)
                        VALUES ($FieldValues)";
        my $sth = $dbh->prepare($db_query);
        $sth->execute;
        $return = &db_errchk;
	$sth->finish;
	return $return;
}

sub db_errchk {
        if ($DBI::err) {
                &errlog("db_errchk",$DBI::errstr);
                return 0;
        } else {
                return 1;
        }
}

return 1;
