#!/usr/bin/perl

################ Feature functions

sub get_feature {
	my($feat,$user) = @_;
	# Get the config information for a single feature.
	# if $user is undefined, grab the default.
	# If $feat is not found, grab the default.
	$db_query = "SELECT feature,enabled,user_configurable,config,cost FROM features_default WHERE feature = '$feat'";
	$sth = $dbh->prepare($db_query);
	$sth->execute;
	$numrows = $sth->rows;
	if ($numrows <= 0) {
		return -1;
	}
	my $hashref = $sth->fetchrow_hashref;
	my %feat_info = %$hashref;
	$sth->finish;

	if (defined($user) && length($user) >= 2) {
		$db_query = "SELECT feature,enabled,config,cost FROM features WHERE feature = '$feat' AND username = '$user'";
		$sth = $dbh->prepare($db_query);
		$sth->execute;
		$numrows = $sth->rows;
		if ($numrows == 1) {
			my $user_configurable = $feat_info{'user_configurable'};
			$hashref = $sth->fetchrow_hashref;
			%feat_info = %$hashref;
			$feat_info{'user_configurable'} = $user_configurable;
		}
		$sth->finish;
	}
	foreach $key (sort(keys(%feat_info))) {
		if ($key eq "user_configurable" || $key eq "enabled") {
			if ($feat_info{$key} == 1) {
				$feat_info{$key} = "t";
			} else {
				$feat_info{$key} = "f";
			}
		}
	}
	return %feat_info;
} #End sub get_feature.

sub set_feature {
	my($user,$assignedby,%feat_info)= @_;
	# Get the config information for a single feature.
	# if user == assignedby and the feature is not user configurable, 
	#  log an error and return failure.
	if ($user eq $assignedby && $feat_info{'user_configurable'} eq "f") {
		errlog("set_feature","Feature $feat_info{'feature'} not user-configurable but $user tried to change it! The front end should not allow this to happen.");
		return -1;
	} #End if
	$db_query = "SELECT feature,enabled,config,cost FROM features WHERE username = '$user' AND feature = '$feat_info{'feature'}'";
	my $sth = $dbh->prepare($db_query);
	$sth->execute;
	$numrows = $sth->rows;
	if ($numrows < 0) {
		errlog("set_feature","Error while trying to retrieve feature info from db: user $user feature $feat_info{'feature'}: DB query $db_query");
		return -1;
	} elsif ($numrows > 0) {
		# A record (or multiple! ack!) already exists in the DB.
		#  delete before inserting the new values.
		$sth->finish;
		$db_query = "DELETE FROM features WHERE username = '$user' AND feature = '$feat_info{'feature'}'";
		$sth = $dbh->prepare($db_query);
		$sth->execute;
		$sth->finish;
	}
	# Okay, insert the new feature config into the db.
	$db_query = "INSERT INTO features (username,feature,enabled,config,cost)
		VALUES('$user','$feat_info{'feature'}','$feat_info{'enabled'}','$feat_info{'config'}','$feat_info{'cost'}')";
	$sth = $dbh->prepare($db_query);
	$sth->execute;
	$sth->finish;
	return 1;
} #End sub set_feature.

return 1;

