#!/usr/bin/perl

### mail functions
sub send_email {
	use Net::SMTP_auth;

	my($sender,$recipient,$subject,$message) = @_;

	if ($sender =~ /</) {
		$sender_smtp = between($sender,"<",">");
	} else {
		$sender_smtp = $sender;
	}
	if ($recipient =~ /</) {
		$recipient_smtp = between($recipient,"<",">");
	} else {
		$recipient_smtp = $recipient;
	}
	my $smtpauth_type = "PLAIN";
	my $smtpauth_user = "staff";
	my $smtpauth_passwd = "PASSWORD";
	my $mailserver = "mail.priv.vectorstar.net";
	my $self = `hostname -f`;
	chomp($self);
###
### UTC and local time seem to work equally well.
###   based on my understanding of the protocol, servers are expected to
###   send with the Date header set to local time. If the timezone is different
###   it is the clients responsibility to correct.
###
###	my $mail_date = `date -u +"\%d \%b \%Y \%T \%z"`;
	my $mail_date = `date +"\%d \%b \%Y \%T \%z"`;
	chomp($mail_date);

	$smtp = Net::SMTP_auth->new($mailserver, Hello => $self);
	if (defined($smtp)) {
		$smtp->auth($smtpauth_type,$smtpauth_user,$smtpauth_passwd);
		$smtp->mail($sender_smtp);
		$smtp->to($recipient_smtp);
		$smtp->data();

		### Now come the headers.
		$smtp->datasend("Date: $mail_date\r\n");
		$smtp->datasend("From: $sender\r\n");
		$smtp->datasend("To: $recipient\r\n");
		$smtp->datasend("Subject: $subject\r\n");
		$smtp->datasend("MIME-version: 1.0\r\n");
#		$smtp->datasend("Content-Type: text/plain; charset=US-ASCII\r\n");
#		$smtp->datasend("Content-Type: text/plain; charset=ISO-8859-1\r\n");
		$smtp->datasend("Content-Type: text/plain; charset=UTF-8\r\n");
#		$smtp->datasend("Content-transfer-encoding: quoted-printable\r\n");

		### Now comes the body.
		$smtp->datasend("\r\n$message\r\n");
		### Close it up!
		$smtp->dataend();
		$smtp->quit;
	} else {
		errlog("send_email()","Could not create smtp connection");
		return 255;
	}
	return 0;
#End sub send_email
}

return 1;

