#!/usr/bin/perl

###################################### Task functions

sub query_task {
	my($service,$date) = @_;
	my $db_query = "SELECT account,assignedby,command,date FROM task_queue WHERE service = '$service' AND date < '$date'";
	my $sth = $dbh->prepare($db_query);
	$sth->execute;
	&db_errchk;
	my $numrows = $sth->rows;

	return ($sth,$numrows);
#End sub query_task.
}

sub send_notice {
	my($account,$message) = @_;
	my $date = time();
	if ($account eq "staff") {
		# Ignore.
		return 1;
	}

	# Expire in 1 week.
	$expiredate = $date + 604800;
	# Pad apostrophes in message
	$message =~ s/'/\\'/g;

	$db_query = "SELECT max(msgid) FROM message_log";
	$sth = $dbh->prepare($db_query);
	$sth->execute;
	my($maxmsgid) = $sth->fetchrow_array;
	$sth->finish;

	my $success = 0;
	while ($success == 0) {
		$maxmsgid++;
		$fields = "msgid,\"from\",\"to\",message,date,expires";
		$values = "'$maxmsgid','NetAdmin','$account','$message','$date','$expiredate'";
		$success = db_insert("message_log",$fields,$values);
	}
	$success = db_insert("message_queue",$fields,$values);
#End sub send_notice.
}

sub add_task {
	my($account,$assignedby,$service,$command) = @_;
	$date = time();

	# Double-escape the current escapes.
        $command =~ s/\\/\\\\/g;
	#single-escape apostrophes to get into the DB.
        $command =~ s/'/\\'/g;  
        
	$fields = "account,assignedby,service,command,date";
	$values = "'$account','$assignedby','$service','$command','$date'";
	$? = db_insert("task_queue",$fields,$values);
#end sub add_task.
}

sub move_task {
	my($account,$assignedby,$service,$command,$date) = @_;
	# Double-escape the current escapes.
        $command =~ s/\\/\\\\/g;
	#single-escape apostrophes to get into the DB.
        $command =~ s/'/\\'/g;  
        
	$fields = "account,assignedby,service,command,date";
	$values = "'$account','$assignedby','$service','$command','$date'";
	$result = db_insert("task_log",$fields,$values);
        
	my $db_query = "DELETE FROM task_queue WHERE account = '$account' AND assignedby = '$assignedby' AND service = '$service' AND command = '$command' AND date = '$date'";
	my $sth = $dbh->prepare($db_query);
	$sth->execute;
	&db_errchk;
	$sth->finish;
#End sub move_task.
}

sub user_modified {
	my($user) = @_;
	my $date = time();

        my $db_query = "UPDATE users SET modified = '$date' WHERE username = '$user'";
        my $sth = $dbh->prepare($db_query);
        $sth->execute;
        &db_errchk;
        $sth->finish;

#End sub user_modified.
}

return 1;

